/* make.h */

/* define the compiler to be used */
#define CI86 0
#define UNIX 0
#define LC   0
#define MSC  1

/*some useful macros*/
#define NUL '\0'
#define isnull(X) (X == '\0' ? TRUE : FALSE)
#define notnull(X) (X == '\0' ? FALSE : TRUE )
#define MkListMem() (struct llist *)get_mem((unsigned) sizeof(struct llist))

/* for the c86 compiler*/
#if CI86
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<=(b)?(a):(b))
#define DEF_CC "\\BIN\\CC%d.EXE"
#define DEF_PASS 4
#endif

/* to run on UNIX */
#if UNIX
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<=(b)?(a):(b))
#define DEF_CC "cc"
#define DEF_PASS 1
#endif

/* to run under Microsoft C */
#if MSC
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<=(b)?(a):(b))
#define DEF_CC "msc"
#define DEF_PASS 1
#endif

/* for the lattice C compiler */
#if LC
/* increase the stack size from default (2K) */
#define SIZ_STK 4096
#define DEF_CC "\\BIN\\LC.COM"
#define DEF_PASS 1
#endif

/* for the fortran compiler, when needed */
/*
#define DEF_CC "\\BIN\\FOR%d.EXE"
#define DEF_PASS 2
*/

/*for some reason, the compilers I use barf on '\\' */
#define BKSLSH '\134'
#define ERROR -1
#define TRUE 1
#define FALSE 0

/*
flags for expand. Report and ignore errors, and no_target means error if
$@ or $* is attempted ( as in $* : a.obj )
*/
#define NO_TARG  2
#define REPT_ERR 1
#define IGN_ERR  0

#define DEFAULT "MAKEFILE"
#define LINE_DEFAULT '+'
#define DRIVE_DEFAULT "C:"

#define INMAX   500     /* maximum input line length */
                        /*(allow for inline expansion) */
#define INMAXSH 80      /*length for short strings*/

#define DEPENDANT   1   /* used in calling getmodified */
#define DEFINED     2

struct llist {
    char *name;
    struct llist *next;
};

struct defnrec {
    char *name;
    int uptodate;
    long modified;
    struct llist *dependson;
    struct llist *howto;
    struct defnrec *nextdefn;
};

struct macrec {
    char *name,*mexpand;
    struct macrec *nextmac;
};

struct rulerec {
    char *dep,*targ;      /*order here is important because there are defaults*/
    struct llist *rule;
    struct rulerec *nextrule;
};

struct dta {
    char dosuse[21];
    char attr_found;
    long dttime;
#if CI86
    unsigned long dta_size;
#endif
#if LC
    long dta_size;
#endif
#if UNIX | MSC
    unsigned long dta_size;
#endif
    char dta_name[13];
    char dta_fill[90];
};
